package botworld;

import java.awt.*;

import prolog.*;
import prolog.math.*;

/**
 * Beacons.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: Beacon.java,v 1.4 2000/08/10 12:51:02 peteg Exp $
 */
public class Beacon extends WorldObject {
    /* Dimensions of a beacon. */
    public static final int height = 10;
    public static final int width = 10;

    /**
     * Constructs a new Beacon with given centre.
     */
    public Beacon(int bid, int centreX, int centreY) {
	id = bid;
	bounds = new Rectangle(centreX - width / 2,
			       centreY - width / 2,
			       height,
			       width);
    }

    public Compound getFact() {
	Term[] args = new Term[] {
	    IntNum.make(id),
	    IntNum.make(bounds.x + width / 2),
	    IntNum.make(bounds.y + height / 2),
	};

	return new Compound("beacon", args);
    }

    public void draw(Graphics g) {
	g.setColor(Color.yellow);

	g.drawOval(bounds.x, bounds.y, width, height);
	g.fillOval(bounds.x + width / 4,
		   bounds.y + height / 4,
		   width / 2,
		   height / 2);
    }
}
