package prolog;

/**
 * Indicates that there was a type or mode error with the arguments passed
 * to a predicate.
 *
 * @author Peter Gammie
 */
public class ArgumentException extends PrologException {
    public ArgumentException(String s) {
	super(s);
    }

    public ArgumentException(String s, Term[] args) {
	super(procArgs(s, args));
    }

    public ArgumentException(String s, Compound t) {
	super(procArgs(s, t));
    }

    public ArgumentException(String s, String f, int a) {
	super(s + f + "/" + a);
    }

    private static String procArgs(String s, Term[] args) {
	StringBuffer out = new StringBuffer(s);

	procArgs(args, out);
	return out.toString();
    }

    private static String procArgs(String s, Compound t) {
	StringBuffer out = new StringBuffer(s);

	out.append(t.functor);
	out.append("(");
	procArgs(t.args, out);
	out.append(")");

	return out.toString();
    }

    private static void procArgs(Term[] args, StringBuffer out) {
	int i = 0;
	while(i < args.length) {
	    out.append(args[i]);
	    if(++i < args.length) {
		out.append(", ");
	    }
	}
    }
}
