package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>abolish/1</TT>: Remove all clauses from a predicate. 
 * <P>
 * <TT>abolish(PredicateName/Arity)</TT>
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: abolish_1.java,v 1.7 2000/08/10 12:51:03 peteg Exp $
 * @see prolog.lib.asserta_1
 * @see prolog.lib.assertz_1
 * @see prolog.lib.retract_1
 */
public class abolish_1 extends CompiledPredicate {
    public abolish_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
//     	System.err.println("abolish: " + t);

	try {
	    Compound arg0 = (Compound)args[0];
 	    String f = ((Compound)arg0.args[0]).functor;
 	    int a = ((Numeric)arg0.args[1]).intValue();

	    ((DynamicPredicate)p.db.get(f, a)).clear();

	    return true;
	} catch (ClassCastException e) {
	    throw new ArgumentException("abolish/1: invalid argument: ", args);
	}
    }
}
