package prolog.lib;

import prolog.*;

/**
 * <TT>asserta/1</TT>: Adds a clause to the start of a predicate.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: asserta_1.java,v 1.12 2000/08/10 12:51:03 peteg Exp $
 * @see prolog.lib.abolish_1
 * @see prolog.lib.assertz_1
 * @see prolog.lib.retract_1
 */
public class asserta_1 extends CompiledPredicate {
    public asserta_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	Compound arg0;

	try {
	    arg0 = (Compound)args[0];
	} catch (ClassCastException e) {
	    throw new ArgumentException("asserta/1: invalid argument: ", args);
	}

	Clause c = new Clause(arg0, p);
	Compound head = c.head;

	String f = head.functor;
	int a    = head.arity;

	try {
	    ((DynamicPredicate)p.db.get(f, a)).puta(c);
	} catch (NullPointerException e) {
	    throw new ArgumentException("asserta/1: predicate is not defined: ", f, a);
	} catch (ClassCastException e) {
	    throw new ArgumentException("asserta/1: predicate is not dynamic: ", f, a);
	}

	return true;
    }
}
