package prolog.lib;

import prolog.*;

/**
 * <TT>call/1</TT>: Succeeds if it's argument is bound to a list of goals
 * (e.g. <TT>','(g1, ','(g2, g3))</TT>) which has a solution, otherwise
 * fails.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: call_1.java,v 1.11 2000/11/04 11:55:06 peteg Exp $
 */
public class call_1 extends Predicate {
    public call_1() {
    }

    public boolean unify(Term[] args, Prolog p) throws ArgumentException {
// 	System.err.println("call/1: goal: " + goal);

	try {
	    p.allocate_ar(null, p.toGoal((Compound)args[0]));
	} catch (ClassCastException e) {
	    throw new ArgumentException("call/1: invalid argument: ", args);
	}

	return true;
    }

    public boolean redo(Term[] args, Prolog p, ChoicePoint cp) {
	throw new RuntimeException("call_1.redo()");
    }

    public boolean compile_call(ClauseCodeGen ccg, Term[] args, boolean lastcall) {
	throw new RuntimeException("call/1: compile_call()");
    }

    public String toString() {
	return "\ncall/1\n";
    }
}
