package prolog.lib;

import java.io.*;

import prolog.*;

/**
 * <TT>consult/1</TT>: Read a file.
 *
 * <TT>consult(+filename)</TT>
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: consult_1.java,v 1.3 2000/07/22 12:25:02 peteg Exp $
 * @see prolog.Prolog#consult
 * @see prolog.Parser
 */
public class consult_1 extends CompiledPredicate {
    public consult_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws PrologException {
	try {
	    String filename = ((Compound)args[0].getBinding()).functor;

	    p.consult(filename);

	    return true;
	} catch (ClassCastException e) {
	    throw new ArgumentException("consult/1: invalid argument: ", args);
	} catch (IOException e) {
	    System.err.print("consult/1: error parsing file: ");
	    e.printStackTrace();
	    throw new ParsingException("consult/1");
	}
    }
}
