package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>halt/1</TT>: Exit the prolog system, with an exit code.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: halt_1.java,v 1.4 2000/08/10 12:51:03 peteg Exp $
 */
public class halt_1 extends CompiledPredicate {
    public halt_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	try {
 	    int arg0 = ((Numeric)args[0]).intValue();

	    System.exit(arg0);

	    return true;
	} catch (ClassCastException e) {
	    throw new ArgumentException("halt/1: invalid argument: ", args);
	}
    }
}
