package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>le/2</TT>: Less than / equal to.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: le_2.java,v 1.7 2000/08/10 12:51:04 peteg Exp $
 */
public class le_2 extends CompiledPredicate {
    public le_2() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	try {
	    Term arg0 = args[0].getBinding(), arg1 = args[1].getBinding();
	    Numeric r0, r1;

	    if(arg0 instanceof Compound) {
		r0 = is_2.eval((Compound)arg0);
	    } else {
		r0 = (Numeric)arg0;
	    }

	    if(arg1 instanceof Compound) {
		r1 = is_2.eval((Compound)arg1);
	    } else {
		r1 = (Numeric)arg1;
	    }

	    return r1.compare(r0) >= 0;

//  	    System.err.println("le: " + arg0.val.toString() + " <= " + arg1.val.toString());
	} catch(ClassCastException e) {
	    throw new ArgumentException("le/2: (<=) invalid arguments: ", args);
	}
    }
}
