package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>listdb/1</TT>: Lookup a predicate and dump it to <TT>stderr</TT>.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: listdb_1.java,v 1.3 2000/08/10 12:51:04 peteg Exp $
 */
public class listdb_1 extends CompiledPredicate {
    public listdb_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	Predicate predicate;

	try {
	    Compound arg0 = (Compound)args[0];
 	    String f = ((Compound)arg0.args[0]).functor;
 	    int a = ((Numeric)arg0.args[1]).intValue();

	    predicate = p.db.get(f, a);
	} catch (ClassCastException e) {
	    throw new ArgumentException("listdb/1: invalid argument: ", args);
	}

	System.err.println(predicate);

	if(predicate instanceof InterpretedPredicate) {
	    System.err.println(((InterpretedPredicate)predicate).index);
	}

	return true;
    }
}
