package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>nocompile/1</TT>: Don't compile this predicate.
 * <P>
 * <TT>nocompile(PredicateName/Arity)</TT>
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: nocompile_1.java,v 1.2 2000/08/10 12:51:04 peteg Exp $
 */
public class nocompile_1 extends CompiledPredicate {
    public nocompile_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws PrologException {
	try {
	    Compound arg0 = (Compound)args[0];
 	    String f = ((Compound)arg0.args[0]).functor;
 	    int a = ((Numeric)arg0.args[1]).intValue();
	    Database db = p.db;

	    if(db.get(f, a) != null) {
                throw new PrologException("nocompile/1: predicate is already defined: " + arg0);
            }

            db.put(f, a, new InterpretedPredicate(a));

	    return true;
	} catch (ClassCastException e) {
	    throw new ArgumentException("nocompile/1: invalid argument: ", args);
	}
    }
}
