package prolog.lib;

import prolog.*;

/**
 * <TT>not_unify/2</TT>: succeeds iff the two argument <TT>Term</TT>s are
 * not unifiable. NOTE: does not bind variables if it succeeds - i.e. it
 * behaves identically to: <TT>not(X = Y)</TT>.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: not_unify_2.java,v 1.2 2000/08/02 11:47:55 peteg Exp $
 */
public class not_unify_2 extends CompiledPredicate {
    public not_unify_2() {
    }

    public boolean exec(Term[] args, Prolog p) {
	Binding trail_top = p.get_trail_top();
	boolean success = !args[0].unify(args[1], null, p);

	if(success) {
	    p.unwind_trail(trail_top);
	}

	return success;
    }
}
