package prolog.lib;

import prolog.*;
import prolog.math.*;

/* partition/4: Partition a list around a pivot. partition(list, int, binding, binding). */
public class partition_4 extends CompiledPredicate {
    private static FunctorArity list_cell = Compound.map_functor_arity(".", 2);
    private static Compound end_of_list = new Compound("[]");

    public partition_4() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	Compound arg0 = (Compound)args[0].getBinding();
	int      arg1 = ((IntNum)args[1].getBinding()).ival;
	Binding  arg2 = (Binding)args[2].getBinding();
	Binding  arg3 = (Binding)args[3].getBinding();

	Compound g_new_list_start = end_of_list,
	    l_new_list_start = end_of_list;

	while(arg0.functor != Parser.empty_list_functor) {
	    Term[] cell_args = new Term[2];
	    Compound cell = new Compound(list_cell, cell_args);

	    cell_args[0] = arg0.args[0];
	    int val = ((IntNum)cell_args[0].getBinding()).ival;

	    if(val <= arg1) {
		cell.args[1] = l_new_list_start;
		l_new_list_start = cell;
	    } else {
		cell.args[1] = g_new_list_start;
		g_new_list_start = cell;
	    }

	    arg0 = (Compound)arg0.args[1].getBinding();
	}

	p.push(arg2, l_new_list_start);
	p.push(arg3, g_new_list_start);

	return true;
    }
}
